From 83107d2fa7a2706c62939be879ffac4a7ca1b90c Mon Sep 17 00:00:00 2001
From: "devang.dixit" <devang.dixit@volansystech.com>
Date: Tue, 13 Apr 2021 01:04:33 +0530
Subject: [PATCH] Temp_patch_13APr

Signed-off-by: devang.dixit <devang.dixit@volansystech.com>
---
 drivers/rtc/rtc-pcf85263.c | 177 ++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 173 insertions(+), 4 deletions(-)

diff --git a/drivers/rtc/rtc-pcf85263.c b/drivers/rtc/rtc-pcf85263.c
index dee243d..96362fb4b 100644
--- a/drivers/rtc/rtc-pcf85263.c
+++ b/drivers/rtc/rtc-pcf85263.c
@@ -24,8 +24,31 @@
 #define REG_STOP 	0x2E
 #define RTC_STOP 	0x01
 
-#define REG_SECONDS  0x01
-#define REG_SECONDS_OS (1 << 7)
+#define REG_BATT_SW     0x26
+#define VAL_BSM_VTH     0x00
+#define VAL_BSM_VBAT    (1<<1)
+#define VAL_BSM_HI      (1<<2)
+#define VAL_BSM_LW      (1<<1)|(1<<2)
+#define VAL_BSTH_V1_5   0x00
+#define VAL_BSTH_V2_8   0x01
+
+#define REG_FLAG_RG     0x2B
+#define VAL_BSF_FLG     0x08
+
+#define REG_TSR_MODE    0x23
+#define VAL_TSR2_FB     (1<<2)
+#define VAL_TSR2_FB_FLG (1<<1) 
+#define VAL_TSR3_FB     (1<<5)
+#define VAL_TSR3_FB_FLG (1<<2) 
+#define VAL_TSR3_LB     (1<<6) 
+#define VAL_TSR1_TS_FE  0x01 
+#define VAL_TSR1_TS_LE  0x10 
+
+#define REG_TSR3_SECONDS  0x1D
+#define REG_TSR2_SECONDS  0x17
+
+#define REG_SECONDS     0x01
+#define REG_SECONDS_OS  (1 << 7)
 
 #define REG_MINUTES  0x02
 #define REG_HOURS    0x03
@@ -34,6 +57,16 @@
 #define REG_MONTHS   0x06
 #define REG_YEARS    0x07
 
+struct rtc_bsf_timestamp {
+        u8 bsf_flag;
+        struct rtc_time tm;
+};
+
+#define RTC_RD_BSF      _IOR('p', 0x15, struct rtc_bsf_timestamp) /* Custom IOCTL command to read BSF-Flag */
+
+
+struct rtc_bsf_timestamp bsf;
+
 struct pcf85263 {
 	struct rtc_device *rtc;
 };
@@ -136,6 +169,78 @@ static int pcf85263_start_rtc(struct i2c_client *client)
 	return 0;
 }
 
+static int pcf85263_rtc_config_batt_sw(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+        // Configure TSR to store Batt SW timestamp
+	err = pcf85263_read(client, REG_TSR_MODE, &value);
+	if (err < 0)
+		return err;
+
+        if(value&VAL_TSR2_FB) {
+	    printk("RTC TSR3 already configured to store SW timestamp\n");
+		return 0;
+	}
+	value = VAL_TSR2_FB;
+	err = pcf85263_write(client, REG_TSR_MODE, value);
+	if (err < 0)
+		return err;
+
+	return 0;
+
+}
+
+static int pcf85263_rtc_read_bsf_flag(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+	err = pcf85263_read(client, REG_FLAG_RG, &value);
+	if (err < 0)
+		return err;
+        bsf.bsf_flag = (value&VAL_BSF_FLG);
+        printk("BSF Flag value : %d, value = %d\n", bsf.bsf_flag, value);
+	return 0;
+}
+
+static int pcf85263_rtc_clear_bsf_flag(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+        err = pcf85263_read(client, REG_FLAG_RG, &value);
+	if (err < 0)
+		return err;
+
+        value &= ~(VAL_BSF_FLG|VAL_TSR2_FB_FLG) ;
+
+	err = pcf85263_write(client, REG_FLAG_RG, value);
+	if (err < 0)
+		return err;
+        printk("RTC BSF flag clear success\n");
+        bsf.bsf_flag = value;
+	return 0;
+}
+
+static int pcf85263_rtc_clear_tsr3f(struct i2c_client *client)
+{
+	u8 value;
+	int err;
+
+        err = pcf85263_read(client, REG_FLAG_RG, &value);
+	if (err < 0)
+		return err;
+
+        value &= ~VAL_TSR3_FB_FLG;
+
+	err = pcf85263_write(client, REG_FLAG_RG, value);
+	if (err < 0)
+		return err;
+	return 0; 
+}
+
 static int pcf85263_rtc_read_time(struct device *dev, struct rtc_time *tm)
 {
 	struct i2c_client *client = to_i2c_client(dev);
@@ -231,13 +336,66 @@ static int pcf85263_rtc_set_time(struct device *dev, struct rtc_time *tm)
 	return pcf85263_start_rtc(client);
 }
 
+static int pcf85263_rtc_read_timestamp2(struct i2c_client *client, struct rtc_time *tm)
+{
+	u8 start = REG_TSR2_SECONDS, regs[6];
+	struct i2c_msg msgs[2];
+	int err;
+
+	msgs[0].addr = client->addr;
+	msgs[0].flags = 0;
+	msgs[0].len = 1;
+	msgs[0].buf = &start;
+
+	msgs[1].addr = client->addr;
+	msgs[1].flags = I2C_M_RD;
+	msgs[1].len = sizeof(regs);
+	msgs[1].buf = regs;
+
+	err = i2c_transfer(client->adapter, msgs, ARRAY_SIZE(msgs));
+	if (err < 0) {
+                printk("I2C RTC timestamp read failed err= %d\n", err);
+		return err;
+        }
+        
+	tm->tm_sec = bcd2bin(regs[0] & 0x7f);
+	tm->tm_min = bcd2bin(regs[1] & 0x7f);
+	tm->tm_hour = bcd2bin(regs[2] & 0x3f);
+	tm->tm_mday = bcd2bin(regs[3] & 0x3f);
+	tm->tm_mon = bcd2bin(regs[4] & 0x1f);
+	tm->tm_year = bcd2bin(regs[5]) + 100;
+
+	return rtc_valid_tm(tm);
+}
+
 #ifdef CONFIG_RTC_INTF_DEV
 static int pcf85263_rtc_ioctl(struct device *dev, unsigned int cmd,
 			     unsigned long arg)
 {
+	struct i2c_client *client = to_i2c_client(dev);
+	int err;
+
 	switch (cmd) {
-	default:
-		return -ENOIOCTLCMD;
+		case RTC_RD_BSF:
+			if(bsf.bsf_flag) {
+                                bsf.bsf_flag = 0;
+                                err = pcf85263_rtc_read_timestamp2(client, &bsf.tm);
+                                if(err < 0)
+                                        printk("RTC read TSR2 failed err = %d\n", err);
+                                else
+                                        printk("RTC read TSR2 Success\n");
+
+				if(copy_to_user((void __user*)arg, &bsf, sizeof(struct rtc_bsf_timestamp)))
+					return -EFAULT;
+				err = pcf85263_rtc_clear_bsf_flag(client);
+				if(err < 0)
+					printk("RTC BSF flag clear failed\n");
+				else
+					printk("RTC BSF Clear success\n");
+			}
+			break;
+		default:
+			return -ENOIOCTLCMD;
 	}
 }
 #else
@@ -275,6 +433,17 @@ static int pcf85263_probe(struct i2c_client *client,
 	i2c_set_clientdata(client, pcf);
 	printk("RTC driver probe done\n");
 
+        err = pcf85263_rtc_config_batt_sw(client);
+        if(err < 0)
+	    printk("RTC BATT SW config failed\n");
+	else
+	    printk("RTC BATT SW config Success\n");
+		
+        err = pcf85263_rtc_read_bsf_flag(client);
+	if(err < 0)
+	    printk("RTC bsf flag read failed");
+	else
+	    printk("RTC BSF Flag read success\n");
 	return 0;
 }
 
-- 
2.7.4

